	 #include <ansi_c.h>
// Voorbeelden van functie aanroepen en het gebruik van pointers.

// definitie van de functie:
float aantalstoelen(float);
void numberofchairs(float, float *);
void wievielstuhle(float []); //  wat ook mag:   void wievielstuhle(float *)

int main(void) {
 char s;
 float y=0;
 float tafels=0;
 float *chairs;
 float tafelsenstoelen[2]; // een array van minimaal 2 en we spreken af dat op plaats 0 het aantal
                           // tafels staat en op plaats 1 het aantal stoelen.
 int i;
//--
// a function call, enkele voorbeelden
//--
 // 1)
 // communicatie via return 
 tafels=10;
 y=0; // begin met y=0. Niet nodig, wel netjes. Niet nodig omdat deze waarde wordt overschreven door volgende statement:
 y=aantalstoelen(tafels);
 printf("voor %f tafels hebben we %f stoelen nodig \n",tafels,y);
 // 2)
 // communicatie via pointer
 chairs=&y; // het adres van geheugenplaats van y wordt in de pointer chairs gezet. (door het & teken dus).
 *chairs=0; // op de geheugenvlaats waar chairs naartoe wijst (*chairs), wordt een nul gezet en straks het resultaat van de berekening.
 numberofchairs(tafels,chairs);
 printf("voor %f tafels hebben we %f stoelen nodig \n",tafels, *chairs);
 // 3)
 // communicatie via adres float.
 y=0;  // de geheugenplaats van y wordt op nul gezet.
 numberofchairs(tafels, &y);   // het teken & geeft aan dat we het geheugenadres doorgeven.
 printf("voor %f tafels hebben we %f stoelen nodig \n",tafels,y);
 // 4)
 // uitzondering arrays
 tafelsenstoelen[0]=10; // het aantal tafels op plaats 0 ---> op plaats 1 wordt het aantal stoelen geschreven door:
 wievielstuhle(tafelsenstoelen);
 printf("voor %f tafels hebben we %f stoelen nodig \n",tafelsenstoelen[0], tafelsenstoelen[1]); 
 //--
 // input karakter om het output scherm niet meteen te laten verdwijnen
 //--
 printf("type enter to continue");
 s=getchar();

 
return 0;
}

// implementatie van de functie:
float aantalstoelen(float tafels) {
			float y=0;
			y=4*tafels; // een simpel wiskundig model: aantal_stoelen = aantal_tafels * 4
			// MERK OP: je kunt hier de waarde van tafels veranderen, door:
			// tafels=999;
			// maar dat wordt NIET doorgegeven naar het main programma. tafels is hier een lokale
			// variable en niet dezelfde variable als de tafels uit main (alleen de waarde is doorgegeven). 
			// Het resultaat van de berekening wordt dus doorgegeven met het return statement. Daarom
			// moet het functietype float zijn, want er wordt een float gereturned.
			return y;
}


void numberofchairs(float tafels, float* chairs) {
	//
	*chairs=tafels*4;
	// MERK OP: hier wordt gecommuniceerd via een pointer, oftewel via een geheugenplaats. De waarde van *chairs
	// is nu dus 'vanzelf' in het hoodprogramma bekend. Er wordt nu niets gereturned
	// en het functietype is dus void=leeg.
	return;
	}

void wievielstuhle(float tafelsenstoelen[]) {  // de lengte wordt dus niet aangegeven; dat bepaat het hoofdprogramma.
// deze funktie hadden we ook met wievielstuhle(float * tafelsenstoelen) kunnen implementeren
	float tafels=tafelsenstoelen[0]; // in array tafelsenstoelen staat op plaats 0 het aantal tafels (als het goed is).
	float y=4*tafels;
	tafelsenstoelen[1]=y; // op plaats 1 zetten we het resultaat van ons model, het aantals stoelen dus.
	// MERK OP: arrays worden bij de aanroep van een funtie altijd als pointer behandeld. Als je de array in de functie
	// verandert, is de verandering dus ook in main doorgevoerd (want de waarde die op de geheugenplaats staat wordt aangepast.) 
	return;
}

